/** weeklyweather.cpp
 * 週間天気予報（気象庁週間予報を参照）
 *
 * @copyright	(c)studio pahoo
 * @author		パパぱふぅ
 * @開発環境	MinGW C++ + cURL + OpenSSL + Boost C++ Libraries
 *					+ WebView2Loader.dll + Leaflet + OSM (+ GoogleMap)
 * @参考URL		https://www.pahoo.org/e-soul/webtech/cpp01/cpp01-16-01.shtm
 */
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include <time.h>
#include <sstream>
#include <string>
#include <winsock2.h>
#include <windows.h>
#include <shlobj.h>
#include <commctrl.h>
#include <boost/format.hpp>
#include <gdiplus/gdiplus.h>
#include <ole2.h>
#include <richedit.h>
#include <boost/property_tree/xml_parser.hpp>
#include <boost/algorithm/string.hpp>
#include "mystrings.h"
#include "apikey.h"
#include "WebView2.h"
#include "pahooWebView2.hpp"
#include "pahooGeocode.hpp"
#include "pahooWeather.hpp"
#include "resource.h"

using namespace std;
using namespace Gdiplus;
using namespace boost;
using namespace boost::property_tree;

// 定数など ==================================================================
#define MAKER		"pahoo.org"			// 作成者
#define APPNAME		"weeklyweather"		// アプリケーション名
#define APPNAMEJP	"週間天気予\報"		// アプリケーション名（日本語）
#define APPVERSION	"3.4.2"				// バージョン
#define APPYEAR		"2020-25"			// 作成年
#define REFERENCE	"https://www.pahoo.org/e-soul/webtech/cpp01/cpp01-16-01.shtm"	// 参考サイト

// ヘルプ・ファイル
#define HELPFILE	".\\etc\\help.chm"

// デフォルト保存ファイル名
#define SAVEFILE	"weeklyweather.csv"

// キャッシュ・ディレクトリ
#define CACHEDIR_WEATHER	"pcache\\"

// キャッシュ保持時間（デフォルト；分）(0：キャッシュしない)
#define LIFE_CACHE_WEATHER	(2 * 60)

// 予報表のID
#define IDC_CAL_LABEL	1501		// 日付
#define IDC_RES_LABEL	1601		// 天気予報
#define IDC_RES_IMAGE	1701		// 天気アイコン
#define IDC_TEMP_LABEL	1801		// 降水確率・最低・最高気温

// 予報表の座標
#define IDC_RES_X		10
#define IDC_RES_Y		430
#define IDC_RES_WIDTH	80

#define FORECAST_HEIGHT	140		// 予報表の高さ

// マップに表示するマーカー画像URL
#define URL_MARKER "https://maps.google.co.jp/mapfiles/ms/icons/yellow-dot.png"
#define MAP_WIDTH		530		// 地図の幅（ピクセル）
#define MAP_HEIGHT		300		// 地図の高さ（ピクセル）

// マップID
#define MAP_ID			"map_id"
// 経度・緯度（初期値）
#define DEF_LONGITUDE	139.766667
double Longitude = DEF_LONGITUDE;
#define DEF_LATITUDE	35.681111
double Latitude  = DEF_LATITUDE;
// 地図拡大率（初期値）
#define DEF_ZOOM	6
int Zoom = DEF_ZOOM;
// 地図の種類（初期値）
#define DEF_MAPTYPE		"GSISTD"
string Maptype = DEF_MAPTYPE;

// 予報地点までの最大距離（km）
#define DISTANCE_MAX	400

// 現在のインターフェイス
HINSTANCE hInst;

// アプリケーション・ウィンドウ
HWND hParent;

//WebView2ウィンドウ
HWND hWebView2;

// ICoreWebView2：pahooWebView2.cpp で定義する．
extern ICoreWebView2* webView2;

// テンポラリファイル名
char tmpFname[MAX_PATH + 1];
wchar_t wUri[MAX_PATH * 2 + 1];

// アプリケーション・ウィンドウ位置
unsigned hParent_X, hParent_Y;

// GDI+用
ULONG_PTR lpToken;

// 検索キー格納変数
string Query;

// エラー・メッセージ格納用【変更不可】
string ErrorMessage;

// UserAgent
string UserAgent;

// pahooWeatherオブジェクト
pahooWeather *pWT;

// pahooGeocodeオブジェクト
pahooGeocode *pGC;

// pahooCacheオブジェクト
pahooCache *pCC;

//WebView2ハンドラの動作を指定する．【変更不可】
enum class eAction {
	GetLatLong,				// 緯度・経度取得してブラウザ表示
	GetZoomType,			// 拡大率・マップタイプ取得してブラウザ表示
	GetLatLongZoomType,		// 緯度・経度・拡大率・マップタイプ取得してブラウザ表示
	Finish					// プログラム終了
};
eAction selectAction = eAction::GetLatLongZoomType;

// バージョン情報
string Version = (boost::format(R"(
%1%  バージョン %2%

本アプリケーションはMIT Licenseです．
個人での無償利用が可能です．自由に改造できます．
再配布の際は，下記の著作権表記，およびURLと本使用条件を必ず明記してください．

　Copyright by (c)studio pahoo, %3%
　https://www.pahoo.org/

なお，本アプリケーションの利用または改造することによって生じた得失ついては一切関知いたしません．WebAPIの変更・停止によって正常に機能しなくなる場合があります．また，二次利用先の組織・企業・団体の目的・内容・活動については一切関知いたしません．

本アプリケーションは，下記のライブラリ，フレームワーク，APIを利用しています．
　MinGW（g++）／Boost C++ライブラリ／libcurl／OpenSSL+／
　WebView2Loader.dll／Leaflet／OpenStreetMap／Googleマップ
　Google Geocoding API／YOLPコンテンツジオコーダAPI
)")
% APPNAMEJP
% APPVERSION
% APPYEAR
).str();

// サブ・プログラム =====================================================
/**
 * パラメータを初期化する．
 * @param	なし
 * @return	なし
 */
void initParameter(void) {
	Query     = "";
	Longitude = DEF_LONGITUDE;
	Latitude  = DEF_LATITUDE;
	Zoom      = DEF_ZOOM;
	Maptype   = DEF_MAPTYPE;
	hParent_X = 0;
	hParent_Y = 0;
}

/**
 * 保存した設定ファイルからパラメータを読み込む．
 * @param	なし
 * @return	なし
 */
void loadParameter(void) {
	ptree pt;

	// 初期値設定
	initParameter();

	// XMLファイル読み込み
	try {
		xml_parser::read_xml(getMyPath(APPNAME) + APPNAME + ".xml", pt);

		// XML解釈
		try {
			// 形式チェック
			if (optional<string>str = pt.get_optional<string>("parameter")) {
			} else {
				return;
			}
			// パラメータ読み込み
			for (auto it : pt.get_child("parameter")) {
				string type= it.second.get_optional<string>("<xmlattr>.type").value();
				if (type == "latitude") {
					Latitude = stod(it.second.data());
				} else if (type == "longitude") {
					Longitude = stod(it.second.data());
				} else if (type == "zoom") {
					Zoom = stoi(it.second.data());
				} else if (type == "maptype") {
					Maptype = (string)it.second.data();
				} else if (type == "wx") {
					hParent_X = (unsigned)stoi(it.second.data());
				} else if (type == "wy") {
					hParent_Y = (unsigned)stoi(it.second.data());
				} else if (type == "query") {
					Query = utf8_sjis((string)it.second.data());
				}
			}
		// 解釈失敗したら初期値設定
		} catch (xml_parser_error& e) {
			initParameter();
			return;
		}
	// 読み込み失敗したら初期値設定
	} catch (xml_parser_error& e) {
		initParameter();
		return;
	}

	// アプリケーション・ウィンドウの位置（デスクトップ範囲外なら原点移動）
	HWND hDesktop = GetDesktopWindow();
	WINDOWINFO windowInfo;
	windowInfo.cbSize = sizeof(WINDOWINFO);
	GetWindowInfo(hDesktop, &windowInfo);
	if (hParent_X >= (unsigned)windowInfo.rcWindow.right) {
		hParent_X = 0;
	}
	if (hParent_Y >= (unsigned)windowInfo.rcWindow.bottom) {
		hParent_Y = 0;
	}
}

/**
 * パラメータを設定ファイルに保存する．
 * @param	なし
 * @return	なし
 */
void saveParameter(void) {
#ifndef CMDAPP
	// アプリケーション・ウィンドウの位置取得
	WINDOWINFO windowInfo;
	windowInfo.cbSize = sizeof(WINDOWINFO);
	GetWindowInfo(hParent, &windowInfo);
	hParent_X = (unsigned)windowInfo.rcWindow.left;
	hParent_Y = (unsigned)windowInfo.rcWindow.top;
	if (hParent_X >= (unsigned)windowInfo.rcWindow.right) {
		hParent_X = 0;
	}
	if (hParent_Y >= (unsigned)windowInfo.rcWindow.bottom) {
		hParent_Y = 0;
	}
#endif

	char lng[SIZE_BUFF + 1], lat[SIZE_BUFF + 1];
	snprintf(lng, SIZE_BUFF, "%.5f", Longitude);
	snprintf(lat, SIZE_BUFF, "%.5f", Latitude);

	// XMLファイルへ書き込む
	ptree pt;
	ptree& child1 = pt.add("parameter.param", lat);
	child1.add("<xmlattr>.type", "latitude");
	ptree& child2 = pt.add("parameter.param", lng);
	child2.add("<xmlattr>.type", "longitude");
	ptree& child3 = pt.add("parameter.param", to_string(Zoom));
	child3.add("<xmlattr>.type", "zoom");
	ptree& child4 = pt.add("parameter.param", Maptype);
	child4.add("<xmlattr>.type", "maptype");
	ptree& child5 = pt.add("parameter.param", (string)to_string(hParent_X));
	child5.add("<xmlattr>.type", "wx");
	ptree& child6 = pt.add("parameter.param", (string)to_string(hParent_Y));
	child6.add("<xmlattr>.type", "wy");
	ptree& child7 = pt.add("parameter.param", sjis_utf8(Query));
	child7.add("<xmlattr>.type", "query");

	const int indent = 4;
	write_xml(getMyPath(APPNAME) + APPNAME + ".xml", pt, std::locale(),
		xml_writer_make_settings<std::string>(' ', indent));
}

/**
 * パラメータを保存した設定ファイルを削除し，パラメータを初期化する．
 * @param	なし
 * @return	なし
 */
void delParameter(void) {
	remove((getMyPath(APPNAME) + APPNAME + ".xml").c_str());

	// 初期値設定
	initParameter();
}

// ブラウザ表示 ==============================================================
/**
 * 天気予報表（HTML）を作成する．
 * @param	なし
 * @return	string 作成したHTML文
 */
string makeForecastHTML(void) {
	static char buff1[SIZE_BUFF + 1];

	string html = (boost::format(R"(<table class="weather">
<caption>%1%の天気予報</caption>
<tr>
)")
% _WS(pWT->jmaWeeklyWeather[0].stationName)		// 予報地点名
).str();

	// 日付の行
	for (int i = 0; i <= 6; i++) {
		snprintf(buff1, SIZE_BUFF,
			"%02d/%02d<span class=\"wsmall\">(%s)</span>",
			pWT->jmaWeeklyWeather[i].month,
			pWT->jmaWeeklyWeather[i].day,
			_WS(pWT->jmaWeeklyWeather[i].day_of_week).c_str());

			html += (boost::format(R"(<td class="dt">%1%</td>
)")
% buff1
).str();
	}

	html += (boost::format(R"(</tr>
<tr>
)")
).str();

	// 天気予報の行
	for (int i = 0; i <= 6; i++) {
		string small1 = "", small2 = "";
		if (pWT->jmaWeeklyWeather[i].rainy.length() > 3) {
			small1 = "<span class=\"wsmall\">";
			small2 = "</span>";
		}
		string temp_max = "-", temp_min = "-";
		if (pWT->jmaWeeklyWeather[i].temp_max != "") {
			temp_max = pWT->jmaWeeklyWeather[i].temp_max + "℃";
		}
		if (pWT->jmaWeeklyWeather[i].temp_min != "") {
			temp_min = pWT->jmaWeeklyWeather[i].temp_min + "℃";
		}
		html += (boost::format(R"(<td class="info">
%1%<br />
<img class="wicon" src="%2%" /><br />
%6%%3%％%7%<br />
%4%/%5%
</td>
)")
% _WS(pWT->jmaWeeklyWeather[i].weather)
% pWT->jmaWeeklyWeather[i].image
% pWT->jmaWeeklyWeather[i].rainy
% temp_max
% temp_min
% small1
% small2
).str();
	}

	html += (boost::format(R"(
</tr>
</table>
)")
).str();

	return html;
}

/**
 * 地図表示HTMLを作成する．
 * @param	なし
 * @return	string 生成したHTML文
 */
string makeMapHTML(void) {
	string script = pGC->makeMapLeaflet(MAP_ID, Longitude, Latitude, Zoom, Maptype);
	string forecast = makeForecastHTML();

	string html = (boost::format(R"(<!DOCTYPE html>
<html lang="ja">
<head>
<meta charset="SJIS">
<title>週間天気予報</title>
<meta name="author" content="studio pahoo" />
<meta name="copyright" content="studio pahoo" />
<meta name="ROBOTS" content="NOINDEX,NOFOLLOW" />
<meta http-equiv="pragma" content="no-cache">
<meta http-equiv="cache-control" content="no-cache">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<style>
body {
	background-color: transparent;
	font-family: 'MS UI Gothic';
}
/* エラー表示 */
p.werror {
	color: red;
	font-size: 16px;
	font-weight: bold;
}
/* 天気予報表 */
table.weather {
	width: %2%px;
	height: %10%px;
	border:solid 1px #000000;
	border-collapse:collapse;
	margin-top:20px;
	line-height:120%%;
}
/* 天気予報表：月日表示部 */
table.weather td.dt {
	width: %2%px;
	border:solid 1px #000000;
	border-collapse: collapse;
	padding:4px;
	white-space:nowrap;
	text-align:center;
	font-size: 14px;
}
/* 天気予報表：予報表示部 */
table.weather td.info {
	width: %2%px;
	border:solid 1px #000000;
	border-collapse: collapse;
	padding:4px;
	white-space:nowrap;
	text-align:center;
	font-size: 14px;
}
/* 天気予報表：予報アイコン */
img.wicon {
	width: 50px;
}
/* 天気予報表：小さい文字 */
span.wsmall {
	font-size: 12px;
}
</style>
%8%
</head>
<body>
<div id="%1%" style="width:%2%px; height:%3%px;"></div>
%9%
<form>
<input id="latitude"  type="hidden" value="%4%" />
<input id="longitude" type="hidden" value="%5%" />
<input id="zoom"      type="hidden" value="%6%" />
<input id="maptype"   type="hidden" value="%7%" />
</form>
</body>
</html>
)")
% MAP_ID						// 地図ID
% MAP_WIDTH						// 地図の幅
% MAP_HEIGHT					// 地図の高さ
% Latitude						// 緯度
% Longitude						// 経度
% Zoom							// 地図拡大率
% Maptype						// 地図タイプ
% script						// 地図描画スクリプト
% forecast						// 天気予報表HTML
% FORECAST_HEIGHT				// 予報表の高さ
).str();

	return html;
}

/**
 * エラーメッセージ表示用HTMLを作成する．
 * @param	なし
 * @return	string 作成したHTML文
 */
string makeErrorHTML(void) {
	string msg;
	if (pGC->isError()) {
		msg = _WS(pGC->getError());
		pGC->resetError();
	} else if (pCC->isError()) {
		msg = _WS(pCC->getError());
		pCC->resetError();
	} else if (pWT->isError()) {
		msg = _WS(pWT->getError());
		pWT->resetError();
	} else {
		msg = ErrorMessage;
	}
	return (boost::format(R"(<!DOCTYPE html>
<html lang="ja">
<head>
<meta charset="SJIS">
<title>エラー発生</title>
<meta name="author" content="studio pahoo" />
<meta name="copyright" content="studio pahoo" />
<meta name="ROBOTS" content="NOINDEX,NOFOLLOW" />
<meta http-equiv="pragma" content="no-cache">
<meta http-equiv="cache-control" content="no-cache">
<style>
body {
	background-color: transparent;
	font-family: 'MS UI Gothic';
}
/* エラー表示 */
p.werror {
	color: red;
	font-size: 16px;
	font-weight: bold;
}
</style>
</head>
<body>
<p class="werror">エラー：%1%．</p>
<form>
<input id="latitude"  type="hidden" value="%2%" />
<input id="longitude" type="hidden" value="%3%" />
<input id="zoom"      type="hidden" value="%4%" />
<input id="maptype"   type="hidden" value="%5%" />
</form>
</body>
</html>
)")
% msg							// エラー・メッセージ
% Latitude						// 緯度
% Longitude						// 経度
% Zoom							// 地図拡大率
% Maptype						// 地図タイプ
).str();
}

/**
 * HTMLファイルを読み込んで，ブラウザ・コントロールに表示する．
 * @param	char* tmpname 読み込むHTMLファイル名
 * @return	なし
 */
void viewBrowser(const char *tmpname) {
	string html;
	string fname;
	ofstream ofs;

	// 表示用HTMLファイル作成
	if ((ErrorMessage == "") && (! pWT->isError()) && (! pGC->isError()) && (! pWT->isError())) {
		html = makeMapHTML();
	} else {
		html = makeErrorHTML();
	}
	ofs.open(tmpname);
	ofs << html;
	ofs.close();

	fname = (string) tmpname;
	std::replace(fname.begin(), fname.end(), '\\', '/');

	if (isWeb2Ready()) {
		webView2->Reload();
	}
}

/**
 * 天気予報情報を取得し，ブラウザ表示を行う．
 * @param	HWND hDlg  ウィンドウハンドル
 * @return	なし
*/
void viewMapList(void) {
	string stationCode;

	// 最も近い予報地点を探す．
	stationCode = pWT->getJmaNearSpot(Longitude, Latitude, 1, DISTANCE_MAX);
//	cout << "stationCode =" << stationCode << endl;
	// 天気予報情報を取得する．
	pWT->jmaGetWeatherForecast(stationCode, 1);
	if (pGC->isError()) {
		ErrorMessage = _WS(pGC->getError());
	} else if (pWT->isError()) {
		ErrorMessage = _WS(pWT->getError());
	}

	// ブラウザ・コントロールに表示
	viewBrowser(tmpFname);

	// エラー・リセット
	ErrorMessage = "";
	pGC->resetError();
	pCC->resetError();
	pWT->resetError();
}

// 保存・コピー =============================================================
/**
 * 指定した都市番号の週間予報をCSVファイルに保存する：保存処理
 * @param	const char* fname 保存ファイル名
 * @param	int cnt   都市番号
 * @return	なし
 */
void __saveCSV(const char *fname, int cnt) {
	ofstream outputfile(fname);

	// 予報地点
	outputfile << "\"" << "緯度" << ",";
	outputfile << Latitude << "\"" << endl;
	outputfile << "\"" << "経度" << ",";
	outputfile << Longitude << "\"" << endl;
	outputfile << "\"" << "予\報地点" << "\",\"";
	outputfile << _WS(pWT->jmaWeeklyWeather[0].stationName) << "\"" << endl;

	// ラベル
	outputfile << "\"" << "月" << "\",";
	outputfile << "\"" << "日" << "\",";
	outputfile << "\"" << "曜日" << "\",";
	outputfile << "\"" << "天候" << "\",";
	outputfile << "\"" << "アイコンURL" << "\",";
	outputfile << "\"" << "降水確率(％)" << "\",";
	outputfile << "\"" << "最高気温(℃)" << "\",";
	outputfile << "\"" << "最低気温(℃)" << "\"" << endl;

	// データ本体
	for (int i = 0; i < 7; i++) {
		outputfile << pWT->jmaWeeklyWeather[i].month << ",";
		outputfile << pWT->jmaWeeklyWeather[i].day << ",";
		outputfile << "\"" << _WS(pWT->jmaWeeklyWeather[i].day_of_week) << "\",";
		outputfile << "\"" << _WS(pWT->jmaWeeklyWeather[i].weather) << "\",";
		outputfile << "\"" << pWT->jmaWeeklyWeather[i].image << "\",";
		outputfile << "\"" << pWT->jmaWeeklyWeather[i].rainy << "\",";
		outputfile << "\"" << pWT->jmaWeeklyWeather[i].temp_max << "\",";
		outputfile << "\"" << pWT->jmaWeeklyWeather[i].temp_min << "\"" << endl;
		if (outputfile.bad()) {
			ErrorMessage = "CSVファイル書き込みエラー";
			break;
		}
	}
	outputfile.close();
}

/**
 * 指定した都市番号の週間天気予報情報をCSVファイルに保存する：ファイルダイアログ
 * @param	int cnt 都市番号
 * @return	なし
 */
void saveCSV(int cnt) {
	static char fname[MAX_PATH + 1];
	strcpy(fname, SAVEFILE);
	OPENFILENAME of;

	// OPENFILENAME構造体のサイズをセット
	memset(&of, 0, sizeof(OPENFILENAME));
	of.lStructSize = sizeof(OPENFILENAME);
	// ダイアログボックスを所有するウィンドウへのハンドル
	of.hwndOwner = hParent;
	of.lpstrFilter = TEXT("CSVファイル(*.csv;*.txt)\0*.csv;*.txt\0すべてのファイル(*.txt)\0*.txt\0\0");
	// ファイル名を格納したバッファのアドレス
	of.lpstrFile = (LPTSTR)fname; 
	// lpstrFileメンバで指定されるバッファのサイズ
	of.nMaxFile = MAX_PATH;
	of.Flags = OFN_OVERWRITEPROMPT;
	// デフォルトの拡張子を格納したバッファのアドレス
	of.lpstrDefExt = TEXT("csv");
	// コモンダイアログの表示
	GetSaveFileName(&of);
	// ファイル保存
	__saveCSV(fname, cnt);
}

/**
 * 指定した都市番号の週間天気予報情報をクリップボードにコピーするための文字列を作成する．
 * @param	int cnt 都市番号
 * @return	string コピーする文字列
 */
string copyText(int cnt) {
	static char buff[SIZE_BUFF + 1];
	ostringstream oss;

	// 予報地点
	oss << "緯度\t" << Latitude  << endl;
	oss << "経度\t" << Longitude << endl;
	oss << "予\報地点\t" << _WS(pWT->jmaWeeklyWeather[0].stationName) << endl;

	// ラベル
	oss << "月日" << "\t";
	oss << "天候" << "\t";
	oss << "アイコンURL" << "\t";
	oss << "降水確率(％)" << "\t";
	oss << "最高気温(℃)" << "\t";
	oss << "最低気温(℃)" << endl;

	// データ本体
	for (int i = 0; i < 7; i++) {
		snprintf(buff, SIZE_BUFF, "%02d/%02d(%s)",
			pWT->jmaWeeklyWeather[i].month, pWT->jmaWeeklyWeather[i].day,
			_WS(pWT->jmaWeeklyWeather[i].day_of_week).c_str());
		oss << buff << "\t";
		oss << _WS(pWT->jmaWeeklyWeather[i].weather) << "\t";
		oss << pWT->jmaWeeklyWeather[i].image << "\t";
		oss << pWT->jmaWeeklyWeather[i].rainy << "\t";
		oss << pWT->jmaWeeklyWeather[i].temp_max << "\t";
		oss << pWT->jmaWeeklyWeather[i].temp_min << endl;
	}
	return oss.str();
}

// バージョン表示ダイアログ =================================================
/**
 * イベントハンドラ：バージョン表示ダイアログ
 * @param	HWND hDlg			ウィンドウ・ハンドラ
 * @paramm	UINT uMsg			メッセージ識別子
 * @param	WPARAM wParam		メッセージの最初のパラメータ
 * @paramL	PARAM lParam		メッセージの2番目のパラメータ
 * @return	INT_PTR CALLBACK	TRUE：メッセージ処理完了／FALSE：未完了
 */
INT_PTR CALLBACK processHelp(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	string help;

	switch (uMsg) {
	// ダイアログ初期化
	case WM_INITDIALOG:
		CenterWindow(hDlg);
		setStrEditBox(hDlg, IDC_TEXT_HELP, Version);
		break;

		// ボタン押下
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		// 実行
		case IDC_BUTTON_OK:
			EndDialog(hDlg, 0);
			break;
		default:
			return 1;
		}
		break;
		// プログラム終了
	case WM_CLOSE:
		EndDialog(hDlg, 0);
		break;
	}
	return 0;
}

/**
 * ヘルプ・ダイアログを作成
 * @param  HWND hDlg		親ウィンドウ・ハンドラ
 * @param  DLGPROC handler	イベント・ハンドラ
 * @return なし
 */
void createHelp(HWND hDlg, DLGPROC handler) {
	DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG_VER), hDlg, (DLGPROC) handler);
}

// WebView2制御用関数群 ======================================================
/**
 * WebView2：ダイアログを初期化する
 * @param	HWND hDlg	親ウィンドウ・ハンドラ
 * @return	なし
*/
void initDialog(HWND hDlg) {
	HICON hIcon;
	ULONG_PTR lpToken;
	GdiplusStartupInput gpSI;
	string stationCode;
	hIcon = (HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_ICON), IMAGE_ICON, 16, 16, 0);
	SendMessage(hDlg, WM_SETICON, ICON_SMALL, (LPARAM)hIcon);
	ErrorMessage = "";

	// カーソルを砂時計に
	SetCursor(LoadCursor(NULL, IDC_WAIT));
	// オプション読み込み
	loadParameter();
	// アプリケーション・ウィンドウ移動
	SetWindowPos(hParent, NULL, hParent_X, hParent_Y, 0, 0, (SWP_NOSIZE | SWP_NOZORDER | SWP_NOOWNERZORDER));
	pWT->resetError();
	pGC->resetError();
	// GDI+初期化
	if (GdiplusStartup(&lpToken, &gpSI, NULL) != Gdiplus::Ok) {
		return;
	}

	// 予報地点情報ファイルを自動更新する．
	pWT->updateFileSpots();

	// テンポラリ・ファイル名取得
	getTempFname(tmpFname);
	size_t wLen = 0;
	mbstowcs_s(&wLen, wUri, MAX_PATH * 2, tmpFname, MAX_PATH);
	// WebView2生成
	hWebView2 = createWebView2(hInst, hDlg, 10, 50, MAP_WIDTH + 30, MAP_HEIGHT + FORECAST_HEIGHT + 60, wUri);

	// Leafletが利用可能かどうか調べる
	const string url = "https://unpkg.com/leaflet@latest/";
	string contents = "";
	int httpStatus = 0;
	bool res = readWebContents(url, UserAgent, &contents, &httpStatus);
	if (res == FALSE) {
		ErrorMessage = "地図描画ライブラリ（Leaflet）が利用できません";
	} else if ((httpStatus < 200) || (httpStatus > 299)) {
		ErrorMessage = "地図描画ライブラリ（Leaflet）が利用できません";
	}

	// メッセージ・ループ
	MSG msg;
	static bool flagWebView2 = false;
	while (GetMessage(&msg, nullptr, 0, 0)) {
		if (msg.message == WM_QUIT) {
			// オプション保存
			// saveOption();
			DestroyWindow(hDlg);
		}
		TranslateMessage(&msg);
		DispatchMessage(&msg);
		if (!flagWebView2 && isWeb2Ready()) {
			// カーソルを砂時計に
			SetCursor(LoadCursor(NULL, IDC_WAIT));
			// 予報地点情報ファイル読み込み
			pWT->readJmaSpots();
			// 最寄の予報地点取得
			stationCode = pWT->getJmaNearSpot(Longitude, Latitude, 1, DISTANCE_MAX);
			// 予報情報の取得
			pWT->jmaGetWeatherForecast(stationCode, 1);
			if (pGC->isError()) {
				ErrorMessage = _WS(pGC->getError());
			} else if (pWT->isError()) {
				ErrorMessage = _WS(pWT->getError());
			}
			// ブラウザ・コントロールに表示
			viewMapList();
			flagWebView2 = true;
		}
	}
}

/**
 * WebView2のパラメータを取り出す．
 * selectActionの値によって動作を変える。
 * @param	char* result	JavaScript終了ハンドラから渡るデータ
 * @return	なし
*/
void execScriptCompleted(string result) {
	double lat = 0, lng = 0;
	int zm = 0;
	string mt;

	// パラメータを読み込む
	vector<string> tokens;
	split(tokens, result, is_any_of(",\""));
	int cnt = 0;
	for (string ss: tokens) {
		switch (cnt) {
			case 1:
				lng = stod(ss);
				break;
			case 2:
				lat = stod(ss);
				break;
			case 3:
				zm = stoi(ss);
				break;
			case 4:
				mt = ss;
				break;
		}
		cnt++;
	}

	switch (selectAction) {
		// 緯度・経度を取得してブラウザに表示
		case eAction::GetLatLong:
			Longitude = lng;
			Latitude  = lat;
			// ブラウザ・コントロールに表示
			viewMapList();
			break;
		// 拡大率・マップタイプを取得してブラウザに表示
		case eAction::GetZoomType:
			Zoom = zm;
			Maptype = mt;
			// ブラウザ・コントロールに表示
			viewMapList();
			break;
		// 緯度・経度・拡大率・マップタイプを取得してブラウザに表示
		case eAction::GetLatLongZoomType:
			Longitude = lng;
			Latitude  = lat;
			Zoom = zm;
			Maptype = mt;
			// ブラウザ・コントロールに表示
			viewMapList();
			break;
		// プログラムを終了する．
		default:
			// テンポラリ・ファイルを削除する．
			Longitude = lng;
			Latitude  = lat;
			Zoom = zm;
			Maptype = mt;
			remove(tmpFname);
			// パラメータを保存する．
			saveParameter();
			// GDI+終了
			GdiplusShutdown(lpToken);
			// プログラムを終了する
			EndDialog(hParent, 0);
			DestroyWindow(hParent);
			break;
	}
//	cout << "Longitude: " << Longitude << endl;
//	cout << "Latitude: " << Latitude << endl;
//	cout << "Zoom: " << Zoom << endl;
//	cout << "Maptype: " << Maptype << endl;
}

/**
 * WebView2：JavaScript終了ハンドラ
 * @param	HWND hDlg			親ウィンドウ・ハンドラ
 * @paramm	UINT uMsg			メッセージ識別子
 * @param	WPARAM wParam		メッセージの最初のパラメータ
 * @paramL	PARAM lParam		メッセージの2番目のパラメータ
 * @return	INT_PTR CALLBACK	TRUE：メッセージ処理完了／FALSE：未完了
*/
class MyScriptCompletedHandler : public ICoreWebView2ExecuteScriptCompletedHandler {
public:
	HRESULT STDMETHODCALLTYPE Invoke(HRESULT error, PCWSTR result) override {
		if (SUCCEEDED(error)) {
			// PCWSTR → char* 変換
			int requiredSize = WideCharToMultiByte(CP_UTF8, 0, result, -1, nullptr, 0, nullptr, nullptr);
			char* buffer = new char[requiredSize];
			WideCharToMultiByte(CP_UTF8, 0, result, -1, buffer, requiredSize, nullptr, nullptr);
			std::string res(buffer);
			// JavaScript終了時に実行する関数
			execScriptCompleted(res);
		}
		return S_OK;
	}

	HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void** ppvObject) override {
		return E_NOINTERFACE;
	}

	ULONG STDMETHODCALLTYPE AddRef(void) override {
		return 1;
	}

	ULONG STDMETHODCALLTYPE Release(void) override {
		return 1;
	}
};

// WebView2のJavaScriptを実行してDOM要素を取得
MyScriptCompletedHandler* scriptCompletedHandler = new MyScriptCompletedHandler();

/**
 * WebView2でスクリプトを実行した後，selectActionで指定したアクションを実行する．
 * @param	なし
 * @param	なし
 * @return	なし
*/
void execScriptAndAction(void) {
	// プログラム終了時に実行するJavaScript
	LPCWSTR js = L"document.getElementById('longitude').value + ',' + document.getElementById('latitude').value + ',' + document.getElementById('zoom').value + ',' + document.getElementById('maptype').value;";

	webView2->ExecuteScript(js, scriptCompletedHandler);
}

// メインウィンドウ ==========================================================
/**
 * イベントハンドラ：メインウィンドウ
 * @param	HWND hDlg			親ウィンドウ・ハンドラ
 * @paramm	UINT uMsg			メッセージ識別子
 * @param	WPARAM wParam		メッセージの最初のパラメータ
 * @paramL	PARAM lParam		メッセージの2番目のパラメータ
 * @return	INT_PTR CALLBACK	TRUE：メッセージ処理完了／FALSE：未完了
 */
INT_PTR CALLBACK processMain(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	wstring val;
	wstring wid;
	GdiplusStartupInput gpSI;
	static int cnt;		// 都市番号
	string stationCode;

	switch (uMsg) {
	// ダイアログ初期化
	case WM_INITDIALOG:
		break;

	// ボタン押下
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		// 検索
		case IDM_EXEC:
		case IDC_BUTTON_EXEC:
			// カーソルを砂時計に
			SetCursor(LoadCursor(NULL, IDC_WAIT));
			// 検索キーがあればジオコードAPI呼び出し
			Query = getStrEditBox(hDlg, IDC_EDIT_QUERY);
			if (Query.length() > 0) {
				if (pGC->searchPoints(_SW(Query), UserAgent, 0) > 0) {
					Longitude = pGC->Ppoints[0].longitude;
					Latitude  = pGC->Ppoints[0].latitude;
				}
				// ブラウザ表示と一覧表示
				selectAction = eAction::GetZoomType;
				execScriptAndAction();
			} else {
				// ブラウザ表示と一覧表示
				selectAction = eAction::GetLatLongZoomType;
				execScriptAndAction();
			}
			// ブラウザ・コントロールに表示
			viewMapList();
			break;

		// リセット
		case IDC_BUTTON_RESET:
		case IDM_RESET:
			setStrEditBox(hDlg, IDC_EDIT_QUERY, "");
			initParameter();
			ErrorMessage = "";
			pGC->resetError();
			pCC->resetError();
			pWT->resetError();
			break;
		// 保存
		case IDC_BUTTON_SAVE:
		case IDM_SAVE:
			saveCSV(cnt);
			break;
		// GoogleAPIキー保存
		case IDM_GOOGLE_APIKEY:
			createSetAPIkey(hDlg, LABEL_GOOGLE_API, FNAME_GOOGLE_API, URL_GOOGLE_API, &pGC->GoogleAPIkey);
			pGC->readGoogleApiKey();
			// GoogleAPIキー未登録ならデフォルトのマップタイプに戻す．
			Maptype = pGC->isGoogleApiKey() ? "GMRD" : DEF_MAPTYPE;
			// ブラウザ・コントロールに表示
			viewMapList();
			break;
		// Yahoo!アプリケーションID保存
		case IDM_YAHOO_APIKEY:
			createSetAPIkey(hDlg, LABEL_YAHOO_API, FNAME_YAHOO_API, URL_YAHOO_API, &pGC->YahooAPIkey);
			// ブラウザ・コントロールに表示
			viewMapList();
			break;
		// キャッシュ・クリア
		case IDM_CLEAR_CACHE:
			pCC->delCache(".+", 0);
			break;
		// 設定クリア＋アプリ終了
		case IDM_CLEAR_PARAMETER:
			delParameter();
			// テンポラリ・ファイル削除
			remove(tmpFname);
			// GDI+終了
			GdiplusShutdown(lpToken);
			EndDialog(hDlg, 0);
			return 0;
			break;
		// ヘルプ
		case IDM_HELP:
			ShellExecute(hDlg, _T("open"), _T(HELPFILE), NULL, NULL, SW_RESTORE);
			break;
		// バージョン表示
		case IDM_VERSION:
			createHelp(hDlg, processHelp);
			break;
		// 解説サイト
		case IDM_PAHOO:
			ShellExecute(NULL, _T("open"), _T(REFERENCE), NULL, NULL, SW_RESTORE);
			break;
		// コピー
		case IDM_COPY:
		case IDC_BUTTON_COPY:
			setClipboardData(copyText(cnt));
			break;
		// 切り取り
		case IDM_DELETE:
			setStrEditBox(hDlg, IDC_EDIT_QUERY, "");
			break;
		// プログラム終了
		case IDM_QUIT:
			selectAction = eAction::Finish;
			execScriptAndAction();
			break;
		default:
			return 1;
		}
		break;

	// プログラム終了
	case WM_CLOSE:
		selectAction = eAction::Finish;
		execScriptAndAction();
		break;
	}
	return 0;
}

// メイン・プログラム =======================================================
/**
 * Windowsメインプログラム
 * @param	HINSTANCE hInstance			インスタンスハンドル
 * @paramm	HINSTANCE hPrevInstance		未使用(常にNULL)：Win16時代の名残
 * @param	LPSTR lpCmdLine				コマンドライン引数
 * @paramL	int nShowCmd				ウィンドウの表示方法
 * @return	int リターンコード
 */
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd) {
	LoadLibrary("RICHED20.DLL");

	// UserAgent生成
	static OSVERSIONINFOEX os;
	GetVersion2(&os);
	UserAgent = (string)"Mozilla/5.0 (" + APPNAME + "/"
		+ APPVERSION + "/" + MAKER
		+ ", Windows NT " + to_string(os.dwMajorVersion) + "."
		+ to_string(os.dwMinorVersion) + ")";

	// pahooCacheオブジェクト
	pCC = new pahooCache(LIFE_CACHE_WEATHER, getMyPath(APPNAME) + CACHEDIR_WEATHER, UserAgent);
	// pahooWeatherオブジェクト
	pWT = new pahooWeather(pCC);
	// pahooGeocodeオブジェクト
	pGC = new pahooGeocode(APPNAME);

	// メイン・ダイアログ
	HWND hDlg = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, (DLGPROC)processMain);
	hInst = hInstance;
	hParent = hDlg;
	// メイン・ダイアログを初期化する．
	initDialog(hDlg);

	// オブジェクト解放
	delete pGC;
	delete pWT;
	delete pCC;

	return 0;
}

/*
 ** バージョンアップ履歴 =====================================================
 *
 * @version 3.4.2 2025/11/08 使用ライブラリ更新
 * @version 3.4.1 2025/07/26 使用ライブラリ更新
 * @version 3.4.0 2025/03/22 Leafletアクセス可否チェック追加，キャッシュシステム不具合修正，使用ライブラリ更新
 * @version 3.3.0 2025/02/23 指定した場所が予報地点外の時にエラー表示
 * @version 3.2.2 2024/11/09 予報地点情報ファイルおよび使用ライブラリを更新
 * @version 3.2.1 2024/08/24 使用ライブラリを更新
 * @version 3.2.0 2024/05/06 起動時に予報地点情報ファイルを自動更新
 * @version 3.1.0 2024/05/03 API入力処理を改良
 * @version 3.0.0 2024/04/29 Edgeブラウザ対応，64ビット対応，予報地点情報ファイル更新
 * @version 2.5.7 2024/03/30 予報地点情報ファイルおよび使用ライブラリを更新
 * @version 2.5.6 2023/12/30 予報地点情報ファイルおよび使用ライブラリを更新
 * @version 2.5.5 2023/11/23 使用ライブラリを更新
 * @version 2.5.4 2023/08/27 予報地点情報ファイルおよび使用ライブラリを更新
 * @version 2.5.3 2023/07/08 使用ライブラリを更新
 * @version 2.5.2 2023/03/18 予報地点情報ファイルおよび使用ライブラリを更新
 * @version 2.5.1 2023/02/11 予報地点情報ファイルおよび使用ライブラリを更新
 * @version 2.5.0 2022/09/24 ウィンドウ位置保存，ライブラリ更新
 * @version 2.4.0 2022/08/20 設定クリア機能を追加
 * @version 2.3.1 2022/08/20 予報地点情報ファイルおよび使用ライブラリを更新
 * @version 2.3   2022/04/10 libcurl・OpenSSLを最新版に更新
 * @version 2.2   2022/03/12 気象庁防災情報XMLのhttps化に対応
 * @version 2.1   2021/04/14 キャッシュ・システム導入：pahooCacheクラス
 * @version 2.0   2021/03/14 気象庁防災情報XMLから情報取得に変更
 * @version 1.2   2020/12/20 leafletスクリプトの参照URL変更
 * @version 1.1   2020/12/05 __jma_readWeeklyWeather() 月日取得方式変更
 * @version 1.0   2020/10/10 初版
 */
